using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class TestHingeJoint : MonoBehaviour {

    public GameObject source;
    public GameObject orientation;
	public Image button;
	public Color enabledCol;
	public Color disabledCol;
    GameObject copied;
	bool physicsEnabled = false;

	void Start()
	{		
		SetColor();
	}
	
    void SetKinematic(Transform t, bool set)
    {
        Rigidbody2D body = t.GetComponent<Rigidbody2D>();
        if (body != null)
        {
            body.isKinematic = set;
        }
        foreach(Transform c in t)
        {
            SetKinematic(c, set);
        }
    }

    public void DoCopy()
    {
        //source.SetActive(false);
        //SetKinematic(copyFrom.transform, true);
        copied = Instantiate(source) as GameObject;
        //SetKinematic(copyFrom.transform, false);
        //source.SetActive(true);
        copied.transform.position = transform.position;
		SetKinematic(copied.transform, !physicsEnabled);
        //copied.SetActive(true);
    }

	public void CopyOrientation()
	{
		for (int i = copied.transform.childCount - 1; i >= 0; i--)
		{
			Transform t = copied.transform.GetChild(i);
			for (int j = 0; j < orientation.transform.childCount; j++)
			{
				Transform copy = orientation.transform.GetChild(j);
				if (copy.name == t.name)
				{
					t.localPosition = copy.localPosition;
					Debug.Log ("Replace angle for "+copy.name+" = "+t.localEulerAngles+", "+t.localRotation);
					t.localRotation = copy.localRotation;
					HingeJoint2D joint = t.GetComponent<HingeJoint2D>();
					if (joint != null)
					{
						Debug.Log("Reference angle " + joint.referenceAngle + " " + copy.GetComponent<HingeJoint2D>().referenceAngle);
					}
					break;
				}
			}
		}
	}

	public void SetColor()
	{
		button.color = physicsEnabled ? enabledCol : disabledCol;
	}

	public void EnablePhysics()
	{		
		physicsEnabled = !physicsEnabled;
		SetColor();
		if(copied)
		{
			SetKinematic(copied.transform, !physicsEnabled);
		}
	}
}
